<?PHP
// +----------------------------------------------------------------------
// | 幻灯片 - 控制器
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\admin\controller;
use app\common\controller\Backend;
use think\Db;
use think\Request;

class banner extends Backend{
    protected $banner;
    protected $horse;

    /**
     * 初始化定义数据模型
     * @todo 无
     * @author 小黄牛
     * @version v1.0.0.1 + 2018.9.29
     * @deprecated 暂不弃用
     * @global 无
     * @return void
    */
    public function _initialize() {
		parent::_initialize();  
        $this->banner = Db::name('banner');
        $this->horse = Db::name('banner_horse');
        $this->type = Db::name('banner_type');
    }
    
    /**
     * 幻灯列表
     * @todo 无
     * @author 小黄牛
     * @version  + 2022.07.05
     * @deprecated 暂不弃用
     * @global 无
     * @return void
    */
    public function index() {
        $param = Request::instance()->param();
        $page_where = [
            'type_id' => $param['type_id'] ?? '',
        ];
        $this->assign('page_where', $page_where);

        $where = '1=1';
        if (!empty($param['type_id'])) $where .= ' AND A.type_id = '.$param['type_id'];

        $list = $this->banner->alias('A')
        ->join('banner_type B', 'A.type_id=B.id')
        ->field('A.*, B.type_title')
        ->order('A.id')
        ->where($where)->order('A.id DESC')->paginate(10, false, [
            'query' => $page_where
        ]);
        $page = $list->render();
        $this->assign('list', $list);
        $this->assign('page', $page);
        $this->assign('type', $this->type->select());
        return $this->fetch();
    }        
    
    /**
     * 新增
     * @todo 无
     * @author 小黄牛
     * @version  + 2022.07.05
     * @deprecated 暂不弃用
     * @global 无
     * @return void
    */
    public function insert() {
        $this->assign('type', $this->type->select());
        # 判断是否AJAX请求
        if (Request::instance()->isAjax()) {
            $param = Request::instance()->param();

            $data = [
                'type_id' => $param['type_id'],
                'href'   => $param['href'],
                'title' => $param['title'],
                'img' => $param['img'],
                'status' => $param['status'] ?? 2,
                'update_time' => time(),
            ];

            $res  = $this->banner->insert($data);
            if ($res !== false) {
                $this->json('00', '新增成功');
            }

            $this->json('01', '新增失败');
        }else{
            return $this->fetch();
        }
    }    
    
    /**
     * 修改
     * @todo 无
     * @author 小黄牛
     * @version  + 2022.07.05
     * @deprecated 暂不弃用
     * @global 无
     * @return void
    */
    public function update() {
        $this->assign('type', $this->type->select());

        $id   = Request::instance()->param('pid');
        $info = $this->banner->where('id', $id)->find();
        # 判断是否AJAX请求
        if (Request::instance()->isAjax()) {
            $param = Request::instance()->param();
            
            $data = [
                'type_id' => $param['type_id'],
                'href'   => $param['href'],
                'title' => $param['title'],
                'img' => $param['img'],
                'status' => $param['status'] ?? 2,
                'update_time' => time(),
            ];

            $res  = $this->banner->where('id', $id)->update($data);
            if ($res !== false) {
                $this->json('00', '修改成功');
            }

            $this->json('01', '修改失败');
        }else{
            $this->assign('info', $info);
            return $this->fetch();
        }
    }      
    
    /**
     * 删除
     * @todo 无
     * @author 小黄牛
     * @version  + 2022.07.05
     * @deprecated 暂不弃用
     * @global 无
     * @return void
    */
    public function delete() {
        $id  = Request::instance()->param('id');
        # 先删除
        $res = $this->banner->where("id = '{$id}'")->delete();
        if ($res) {
            $this->json('00', '删除成功');
        }

        $this->json('01', '删除失败');
    }        
    
    /**
     * 首页跑马灯
     * @todo 无
     * @author 小黄牛
     * @version  + 2022.07.05
     * @deprecated 暂不弃用
     * @global 无
     * @return void
    */
    public function horse_index() {
        $list = $this->horse->paginate(10);
        $page = $list->render();
        $this->assign('list', $list);
        $this->assign('page', $page);
        return $this->fetch();
    }              
    
    /**
     * 修改
     * @todo 无
     * @author 小黄牛
     * @version  + 2022.07.05
     * @deprecated 暂不弃用
     * @global 无
     * @return void
    */
    public function horse_update() {
        $id   = Request::instance()->param('pid');
        $info = $this->horse->where('id', $id)->find();
        # 判断是否AJAX请求
        if (Request::instance()->isAjax()) {
            $param = Request::instance()->param();
            
            $data = [
                'des'   => $param['des'],
                'title' => $param['title'],
                'href' => $param['href'],
                'img' => $param['img'],
                'status' => $param['status'] ?? 2,
                'update_time' => time(),
            ];

            $res  = $this->horse->where('id', $id)->update($data);
            if ($res !== false) {
                $this->json('00', '修改成功');
            }

            $this->json('01', '修改失败');
        }else{
            $this->assign('info', $info);
            return $this->fetch();
        }
    }        
}