<?php
/**
 * +----------------------------------------------------------------------
 * PHP代码审计插件
 * +----------------------------------------------------------------------
 * 官网：https://www.sw-x.cn
 * +----------------------------------------------------------------------
 * 作者：小黄牛 <1731223728@qq.com>
 * +----------------------------------------------------------------------
 * 开源协议：http://www.apache.org/licenses/LICENSE-2.0
 * +----------------------------------------------------------------------
*/

// 目录分割符
define('DS', DIRECTORY_SEPARATOR);
// 前端静态入口
define('__HOME__', str_replace('//', '/', str_replace('\\','/', dirname($_SERVER['PHP_SELF'])).'/CodeAudit/public'));
// 缓存根目录
define('Runtime', __DIR__ .DS. 'runtime' .DS);

// 引入其他工具
require_once __DIR__ .DS. 'controller' .DS. 'basics' .DS. 'Controller.php';
require_once __DIR__ .DS. 'tool' .DS. 'File.php';
require_once __DIR__ .DS. 'tool' .DS. 'Decompose.php';

class CodeAudit
{
    /**
     * 表单值
    */
    private $param = [];
    
    /**
     * 监听审计页面
     * @author 小黄牛
     * @version v2.5.26 + 2022-07-14
     * @param string $path 设置监听目录
    */
    public function handle($path) {
        if ($_SERVER['REQUEST_METHOD'] == 'GET') {
            $this->param = $_GET;
        } else {
            $this->param = $_POST;
        }
        $this->param['path'] = str_replace('/', DS, $path);

        // 分流 
        if (isset($this->param['route'])) {
            return $this->exec($this->param['route']);
        }
        // 列表页
        return $this->exec('index');
    }

    /**
     * 处理事件分流
     * @author 小黄牛
     * @version v2.5.26 + 2022-07-14
     * @param string $route 路由
    */
    private function exec($route) {
        require_once __DIR__ .DS. 'controller' .DS. $route. '.php';
        $new = new $route($this->param);
        return $new->handle();
    }
}