<?php
require_once __DIR__ .DS. 'public' .DS. 'header.php';
?>
<script src="<?php echo __HOME__;?>/highlightjs/highlight.min.js"></script>
<link rel="stylesheet" type="text/css" href="<?php echo __HOME__;?>/highlightjs/styles/vs2015.min.css"/>


<h1 class="site-h1">
    审查报告
</h1>

<table class="layui-table">
    <colgroup>
        <col width="60">
        <col width="90">
        <col width="120">
        <col>
        <col>
        <col>
    </colgroup>
    <thead>
        <tr>
            <th style="text-align: center;">编号</th>
            <th style="text-align: center;">错误行数</th>
            <th style="text-align: center;">错误类型</th>
            <th>原因</th>
            <th>代码</th>
            <th>上下文</th>
        </tr> 
    </thead>
    <tbody>
        <?php foreach ($list as $k=>$v) { ?>
        <tr>
            <td style="text-align: center;"><?php echo $k+1;?></td>
            <td style="text-align: center;">
                <?php echo $v['line'];?>
            </td>
            <td style="text-align: center;">
                <?php 
                    switch ($v['type']) {
                        case 1: echo '文件名'; break;
                        case 2: echo 'Class名'; break;
                        case 3: echo 'Function名'; break;
                        case 4: echo '文件注释说明'; break;
                        case 5: echo '变量名'; break;
                        case 6: echo 'If嵌套'; break;
                        default: echo '未知错误'; break;
                    }
                ?>
            </td>
            <td>
                <?php echo $v['msg'];?>
            </td>
            <td>
                <?php if ($v['code']) { ?>
                    <pre><code class="php"><?php echo $v['code'];?></code></pre>
                <? } ?>
            </td>
            <td>
                <?php if ($v['context']) { ?>
                    <pre><code class="php"><?php echo $v['context'];?></code></pre>
                <? } ?>
            </td>
        </tr>
        <? } ?>
    </tbody>
</table>

<script>
//注意进度条依赖 element 模块，否则无法进行正常渲染和功能性操作
layui.use(['element', 'layer'], function(){
  var element = layui.element;
  var layer = layui.layer;
});

hljs.initHighlightingOnLoad();
</script>

<?php
require_once __DIR__ .DS. 'public' .DS. 'footer.php';
?>