<?php
require_once __DIR__ .DS. 'public' .DS. 'header.php';
?>
<style>
.layui-table td, .layui-table th {
    padding: 9px 15px;
}
</style>
<table class="layui-table">
    <colgroup>
        <col width="60">
        <col width="120">
        <col>
    </colgroup>
    <thead>
        <tr>
            <th style="text-align: center;">序号</th>
            <th style="text-align: center;">类型</th>
            <th>要求</th>
        </tr> 
    </thead>
    <tbody>
        <tr>
            <td style="text-align: center;">1</td>
            <td style="text-align: center;">文件注释</td>
            <td>
                每个文件的顶部开头，都需要使用注释说明该文件的用处、负责人（不少于2行），推荐使用以下注释风格：<br/>
                <pre>/**
 * +----------------------------------------------------------------------
 * PHP代码审计插件
 * +----------------------------------------------------------------------
 * 官网：https://www.sw-x.cn
 * +----------------------------------------------------------------------
 * 作者：小黄牛 <1731223728@qq.com>
 * +----------------------------------------------------------------------
 * 开源协议：http://www.apache.org/licenses/LICENSE-2.0
 * +----------------------------------------------------------------------
*/</pre>
            </td>
        </tr>
        <tr>
            <td style="text-align: center;">2</td>
            <td style="text-align: center;">文件名</td>
            <td>
                1、若该文件用于定义Class类，则文件名要与类名一致（包括大小写）；<br/>
                2、其他情况下，文件名只能使用数字、字母、下划线组成（包不区分大小写）。
            </td>
        </tr>
        <tr>
            <td style="text-align: center;">3</td>
            <td style="text-align: center;">类名</td>
            <td>
                使用大驼峰命名，检测时，是使用<code>ucwords()</code>函数进行校验。
            </td>
        </tr>
        <tr>
            <td style="text-align: center;">4</td>
            <td style="text-align: center;">函数名</td>
            <td>
                使用小驼峰命名，不支持蛇形、大驼峰等函数命名方式。
            </td>
        </tr>
        <tr>
            <td style="text-align: center;">5</td>
            <td style="text-align: center;">变量名</td>
            <td>
                不支持大写、数字的变量命名，仅支持蛇形命名。
            </td>
        </tr>
        <tr>
            <td style="text-align: center;">6</td>
            <td style="text-align: center;">if嵌套</td>
            <td>
                if嵌套层级不能超过3层。
            </td>
        </tr>
    </tbody>
</table>

<script>
//注意进度条依赖 element 模块，否则无法进行正常渲染和功能性操作
layui.use(['element', 'layer'], function(){
  var element = layui.element;
  var layer = layui.layer;
});
</script>


<?php
require_once __DIR__ .DS. 'public' .DS. 'footer.php';
?>