<?php
require_once __DIR__ .DS. 'public' .DS. 'header.php';
?>

<h1 class="site-h1">
    PHP代码审计
    <button type="button" class="layui-btn layui-btn-danger" style="float: right;margin: 10px 0 0 10px" onclick="resets()">重置</button>
    <button type="button" class="layui-btn layui-btn-normal" style="float: right;margin-top: 10px" onclick="check_all()">批量审查</button>
    <button type="button" class="layui-btn layui-btn-normal" style="float: right;margin-top: 10px" onclick="explain()">规范要求</button>
</h1>


<table class="layui-table">
    <colgroup>
        <col width="60">
        <col>
        <col width="100">
        <col width="60">
        <col width="60">
        <col width="75">
        <col width="65">
    </colgroup>
    <thead>
        <tr>
        <th>序号</th>
        <th>文件路径</th>
        <th style="text-align: center;">文件类型</th>
        <th>状态</th>
        <th>评分</th>
        <th style="text-align: center;">错误数</th>
        <th style="text-align: center;">操作</th>
    </tr> 
    </thead>
    <tbody>
        <?php foreach ($list as $v) { ?>
        <tr data-id="<?php echo $v['id'];?>" id="log-<?php echo $v['id'];?>" <?php if($v['status']==3) {?>style="color:red;"<?php }?> <?php if($v['status']==4) {?>style="color:#5FB878"<?php }?>>
            <td style="text-align: center;"><?php echo $v['key'];?></td>
            <td>
                <?php echo $v['file'];?>
            </td>
            <td style="text-align: center;color:#666">
                <?php 
                    switch ($v['type']) {
                        case 1: echo 'Class'; break;
                        case 2: echo 'Function'; break;
                        case 3: echo '配置文件'; break;
                        case 4: echo '其他'; break;
                        default: echo '未收录'; break;
                    }
                ?>
            </td>
            <td style="text-align: center;">
                <i class="layui-icon t1" style="color:#1E9FFF;<?php if($v['status']==1) {?>display:block<?php }?>">&#xe652;</i>  
                <i class="layui-icon t2" style="color:#2F4056;<?php if($v['status']==2) {?>display:block<?php }?>">&#xe601;</i>  
                <i class="layui-icon t3" style="<?php if($v['status']==3) {?>display:block<?php }?>">&#x1006;</i>  
                <i class="layui-icon t4" style="<?php if($v['status']==4) {?>display:block<?php }?>">&#xe605;</i>  
            </td>
            <td style="text-align: center;" class="score">
                <?php echo $v['score'];?>
            </td>
            <td style="text-align: center;" class="error">
                <?php echo $v['error'];?>
            </td>
            <td style="text-align: center;">
                    
                <button onclick="single('<?php echo $v['id'];?>')" type="button" class="layui-btn layui-btn-normal layui-btn-xs" style="<?php if($v['status']!=1) {?>display:none<?php }?>">审查</button>

                <button onclick="report('<?php echo $v['id'];?>')" type="button" class="layui-btn layui-btn-danger layui-btn-xs" style="<?php if($v['status']!=3) {?>display:none<?php }?>">报告</button>
            </td>
        </tr>
        <tr id="progress-<?php echo $v['id'];?>" class="progress">
            <td colspan=10>
                <div class="layui-progress" lay-showpercent="true"> 
                    <div class="layui-progress-bar layui-bg-blue" lay-percent="0%"></div> 
                </div>
            </td>
        </tr>
        <? } ?>
    </tbody>
</table>

<script>
//注意进度条依赖 element 模块，否则无法进行正常渲染和功能性操作
layui.use(['element', 'layer'], function(){
  var element = layui.element;
  var layer = layui.layer;
});
function explain() {
    layer.open({
		type: 2,
		title: '规范要求',
		shadeClose: true,
		shade: false,
		maxmin: true,
		area: ['70%', '70%'],
		content: '?route=explain'
	});
}
// 查看报告
function report(id) {
    layer.open({
		type: 2,
		title: '审查报告',
		shadeClose: true,
		shade: false,
		maxmin: true,
		area: ['90%', '90%'],
		content: '?route=error_query&id='+id
	});
}

// 发起批量检测
function check_all() {
    layer.confirm('确认发起批量审查吗？', {
        btn: ['确认','取消']
    }, function(){
        $('table tbody tr').each(function(){
            runGo($(this).attr('data-id'), false);
        })
    })
}

// 创建一个定时器
function createTime(id){
    let sv;
    sv = setInterval(function(){
        $.ajax({
            type: 'post',
            data: {
                id:id,
                'route':'speed_query'
            },
            url: "?",
            success: function(data) {
                $('#log-'+id+' .score').text(data.data.score);
                $('#log-'+id+' .error').text(data.data.error);
                $('#progress-'+id+' .layui-progress-bar').attr('lay-percent', data.data.num+'%');
                $('#progress-'+id+' .layui-progress-bar').css('width', data.data.num+'%');

                if (data.data.num == 100) {
                    $('#progress-'+id).css('display', 'none');
                    $('#log-'+id+' .layui-icon').hide();
                    // 这里还需要判断评分，100分打勾，其他打X并且显示报告按钮
                    if (data.data.score == 100) {
                        $('#log-'+id+' .t4').show();
                        $('#log-'+id).css('color', '#5FB878');
                    } else {
                        $('#log-'+id+' .t3').show();
                        $('#log-'+id).css('color', 'red');
                        $('#log-'+id+' .layui-btn-danger').show();
                    }
                    clearInterval(sv);
                }
            }
        });
    }, 100)
}

// 定时器记录
var timeAll = [];
function single(id) {
    layer.confirm('确认运行？', {
        btn: ['确认','取消']
    }, function(){
        layer.closeAll();
        runGo(id)
    });
}
function runGo(id) {
    // 异步发送请求
    $.ajax({
        type: 'post',
        data: {
            'id':id,
            'route':'run_audit_single'
        },
        url: "?",
        success: function(data) {
            layer.msg(data.msg);
        }
    });
    // 切换状态
    $('#log-'+id+' .layui-btn-normal').hide();
    $('#log-'+id+' .layui-icon').hide();
    $('#log-'+id+' .t2').show();
    $('#progress-'+id).css('display', 'table-row');
    // 启动一个定时器查询进度
    createTime(id)
}

function resets() {
    layer.confirm('确认初始化审计记录？', {
        btn: ['确认','取消']
    }, function(){
        layer.closeAll();
        var index = layer.load(1, {
            shade: [0.1,'#000']
        });
        $.ajax({
            type: 'post',
            data: {
                'route':'reset'
            },
            url: "?",
            success: function(data) {
                layer.close(index);
                layer.msg(data.msg);
                if (data.code == '200') {
                    window.setTimeout(function(){
                        window.location.reload();
                    }, 600); 
                }
            }
        });
    });
}
</script>



<?php
require_once __DIR__ .DS. 'public' .DS. 'footer.php';
?>